function convertSingle( ) {

//dumpme(_getFolderOpenTag("xx", "tst"));

convertToBmFile();

//readFile();
//saveFilePos();
}


function convertToBmFile()
{

  var data = readFile();
  
  dumpd("readback");

  var savePoint = saveFilePos();

  dumpd("gotpoint");

  var page = parseData(data);

  dumpd("pageparsed");

//var page = "hehe"

  saveFile(savePoint, page);

window.close();
}

function readFile()
{
  var theFile = null;
  var initialDir = null;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
  fp.init(null, "Open a spoofmark file (rdf, ini or txt)", Components.interfaces.nsIFilePicker.modeOpen);
  if (fp.show() == Components.interfaces.nsIFilePicker.returnOK) {

    var inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
    var mode_mask = 0x01, perm_mask = 0;	// open(2)
    inputStream.init(fp.file, mode_mask, perm_mask, 0);
    var jsstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
    jsstream.init(inputStream);

dumpd(fp.file.fileSize);

    if (fp.file.fileSize<1500000) {
      var data = jsstream.read(fp.file.fileSize);
      return data;
    }
    dumpme("filesize over 1Mb too big ?? correct file ??");
  }else {
    dumpme("you didn't select an input file");
  }   
  halt();
}



function saveFilePos()
{
  var theFile = null;
  var initialDir = null;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
  fp.init(null, "Save as bookmark file", Components.interfaces.nsIFilePicker.modeSave);
  fp.displayDirectory = initialDir;
  fp.defaultString = "mySpoofmarks.html";
  if (fp.show() == Components.interfaces.nsIFilePicker.returnOK) {

    theFile = fp.file; // returns nsilocalfile
    //theFile = fp.file.clone(); // returns nsifile

    return theFile;
  }
  if (fp.file.exists) {
    dumpme("wants to replace the file not ready yet");
    // ev try to remove the file saveFilePos(); // later
    saveFilePos();
  } else {
    dumpme("you didn't select an output file");
    halt();
  }
}



function saveFile(savePoint, page)
{
    // resolution at http://www.captain.at/programming/xul/

  savePoint.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 777 );

  var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
  var h1_flag = 0x04, h2_flag = 0x08, h3_flag = 0x20;	// handling flags, readwrite, createfile, truncate
  outputStream.init( savePoint, h1_flag | h2_flag | h3_flag, 777, 0 );
  var result = outputStream.write( page, page.length );
  outputStream.close();

  
  dumpd(result); // how many bites were written compare to how many read at start

}





/////// parse workload


function parseData(data) 
{

  var reTstRdf=/.*rdf/gi;
  var reTstIni=/^.*\[\w+\]/ig;
  var reTstTxt=/([^\f\n\r\t\v;]+);([^\f\n\r\t\v;]+);([^\f\n\r\t\v;]+)/gi;
  var reTstTxt2=/D\w+[=\s]+(.*)\s+T\w+[=\s]+(\S+).*\s+R\w+[=\s]+(\S+)/gi;
  var page;

  var evalYet = false;  // test first if it should step into an if

  // a bit code overhead

  if (!evalYet && reTstIni.test(data)){
    dumpd("ini select");
    page = reWrite(data, "ini");
    evalYet = true;
  }
  if (!evalYet && reTstRdf.test(data)){
    dumpd("rdf select");
    page = reWrite(data, "rdf");
    evalYet = true;
  }
  if (!evalYet && reTstTxt.test(data)){
    dumpd("txt select");
    page = reWrite(data, "txt");
    evalYet = true;
  }
  if (!evalYet && reTstTxt2.test(data)){
    dumpd("txt2 select");
    page = reWrite(data, "txt2");
    evalYet = true;
  }

  if (evalYet) {
    return page;
  }

  dumpme("no file scheme (rdf, ini, txt) matched\nrdf starts with \"<rdf\"\nini starts with \"[Details]\"\ntxt starts with \"uri;uri;uri\" ");

  halt();
}


function reWrite(data, format)
{
  // header
  var page = _getBmFileHeader();
  page += _getFolderOpenTag("Spoofmarks created on " + _getDateString(),"");

  // infofolder / regex
  switch (format)
  {
  case "ini":
    var reNIni=/N\w+[=\s]+(.*)\s+A\w+[=\s]+(.*)\s+S\w+[=\s]+(.*)/gi;
    reNIni.lastIndex=0;
    if (reNIni.test(data)) {
      reNIni.lastIndex=0;
      var Info = reNIni.exec(data);
      dumpd(Info[1] +"\n"+ Info[2] +"\n"+ Info[3]);
      page += _getFolderOpenTag(Info[1], " by " + Info[2] + " says to contain " + Info[3] + " spoofs"); 
    } else {
      page += _getFolderOpenTag("spoofs.ini", ""); 
    }
    reParse = /D\w+[=\s]+(.*)\s+U\w+[=\s]+(\S+).*\s+R\w+[=\s]+(\S+)/gi;
    break;
  case "rdf":
    page += _getFolderOpenTag("refspoof.rdf", ""); 
    reParse = /NS1:U\w+[=\s"]+([^\s"]+).*\s+NS1:R\w+[=\s"]+([^\s"]+)/gi;
    break;
  case "txt":
    page += _getFolderOpenTag("spoofs.txt", ""); 
    reParse = /([^\f\n\r\t\v;]+);([^\f\n\r\t\v;]+);([^\f\n\r\t\v;]+)/gi;
    break;
  case "txt2":
    page += _getFolderOpenTag("spoofmix.txt", ""); 
    reParse = /D\w+[=\s]+(.*)\s+T\w+[=\s]+(\S+).*\s+R\w+[=\s]+(\S+)/gi;
    break;
  default:
    dumpme("no valid file format selected");
    halt();
  }

  dumpd(page);

  reParse.lastIndex=0;
  var pos; // used that test doesnt eat every second record
  var constrBookm;

  // records iterate
  while (reParse.test(data)){
  //for (var i=0;  i <= 5; i++){ //tst

    reParse.lastIndex = pos;
    constrBookm = reParse.exec(data);

  switch (format)
  {
  case "txt":
  case "ini":
    constrBookm[2] = constrBookm[2].replace("http://", "spoof://");
    constrBookm[3] = constrBookm[3].replace("http://", "ref://");
    break;
  case "rdf":
    constrBookm[3] = constrBookm[2].replace("http://", "ref://"); // format has no description field
    constrBookm[2] = constrBookm[1].replace("http://", "spoof://");
    break;
  case "txt2":
    constrBookm[2] = "spoof://" + constrBookm[2]; // format has no leading http
    constrBookm[3] = "ref://" + constrBookm[3];
  }

    //dumpd(constrBookm[1] +"\n"+ constrBookm[2] +";"+ constrBookm[3]")
    page += _getBmTag(constrBookm[1], constrBookm[2]+";"+ constrBookm[3], "");
    pos = reParse.lastIndex;
  }

  page += _getFolderCloseTags(3);  // needs 1 tag more .. header
  //dumpd(page);
  dumpd("fullParsed");

  return page;

  halt();
}



/////// Helper Functions


function _getBmFileHeader()
{
  headerTag = "<!DOCTYPE NETSCAPE-Bookmark-file-1>\n<DL><p>\n\n"
  return headerTag;
}

function _getFolderOpenTag(name, description)
{
  openTag = "<DT><H3>"+ name + "</H3>\n";
  openTag += "<DD>" + description + "\n<DL><p>\n\n\n";
  return openTag;
}


function _getFolderCloseTags(count)
{
 closeTags = "";
 for (var i=1;i<=count;i++){  
   closeTags += "\n</DL>";
 }
 return closeTags;
}

function _getBmTag(name, uri, description)   
{
  bmTag = "<DT><A HREF=\""+ uri + "\">";
  bmTag += name + "</A>\n";
  bmTag += "<DD>" + description + "\n\n"
  return bmTag;
}


function _getDateString()
{
  var date = new Date();
  var dateString = "";
  dateString += date.getFullYear() + "-";
  dateString += this._padZeros2(date.getMonth(), true) + "-";
  dateString += this._padZeros2(date.getDate(), false) + " ";
  dateString += this._padZeros2(date.getHours(), false) + ":";
  dateString += this._padZeros2(date.getMinutes(), false);
  return dateString;
}

function _padZeros2(aNumber, aShouldIncrement)
{
  if (aShouldIncrement)
    ++aNumber;
  if (aNumber < 10) 
    return "0" + aNumber;
  return aNumber;
}

